from typing import List
from pathlib import Path

from edalize.build_runners.make import Make
from edalize.utils import EdaCommands

class Sshmake(Make):

    def __init__(self, flow_options):
        super().__init__(flow_options)
        self.build_host = "5446.54.40.138"

    def get_build_command(self):
        return ("sh", ["launchme.sh"])

    def write(self, commands: EdaCommands, work_root: Path):
        # Write Makefile
        super().write(commands, work_root)

        # Write launcher script that copies files to build host and runs it
        outfile = work_root / Path("launchme.sh")
        with open(outfile, "w") as f:
            f.write("#Auto generated by Edalize\n\n")
            f.write(f"scp -r {work_root} {self.build_host}\n")
            f.write(f"ssh {self.build_host} make " + ' '.join(self.build_options)+ "\n")
